/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package homework4websocketserver;

import java.net.InetSocketAddress;
import java.net.SocketPermission;
import java.util.ArrayList;
import java.util.List;
import org.java_websocket.WebSocket;
import org.java_websocket.handshake.ClientHandshake;
import org.java_websocket.server.WebSocketServer;

/**
 *
 * @author spdue7cb
 */
public class ChatServer extends WebSocketServer {
    
    private List<WebSocket> sockets = new ArrayList<WebSocket>();

    public ChatServer(InetSocketAddress address) {
        super(address);
    }

    @Override
    public void onClose(WebSocket conn, int code, String reason, boolean remote) {
        if (sockets.remove(conn)) {
            System.out.println("connection removed from list");
        }
        System.out.println("closed " + conn.getRemoteSocketAddress() + " with exit code " + code + " additional info: " + reason);
    }

    @Override
    public void onError(WebSocket conn, Exception ex) {
        System.err.println("an error occured on connection " + (conn != null ? conn.getRemoteSocketAddress() : "null") + ":" + ex);
    }

    @Override
    public void onMessage(WebSocket conn, String message) {
        System.out.println("received message from " + conn.getRemoteSocketAddress() + ": " + message);
        conn.send("echo response: "+message);
        for(WebSocket socket : sockets) {
            if (socket != conn) {
                socket.send(message);
            }
        }
    }

    @Override
    public void onOpen(WebSocket conn, ClientHandshake handshake) {
        System.out.println("new connection to " + conn.getRemoteSocketAddress());
        if (sockets.add(conn)) {
            System.out.println("connection added to list");
        }
    }
    
}
